Index: freebsd/sys/kern/kern_intr.c
===================================================================
--- freebsd/sys/kern/kern_intr.c	(revision fb288fabeac198d19869ad6d6c6159d69d418d87)
+++ freebsd/sys/kern/kern_intr.c	(revision 172f2acb2b0ad183cb2360843e67aa86ca26a210)
@@ -67,4 +67,6 @@
   #include <machine/rtems-bsd-thread.h>
   #define RTEMSBSD_SWI_WAKEUP_EVENT RTEMS_EVENT_31
+  #undef ticks
+  #include <rtems/score/threadimpl.h>
 #endif /* __rtems__ */
 #include <machine/stdarg.h>
@@ -196,5 +198,9 @@
 
 	/* Update name and priority. */
+#ifndef __rtems__
 	strlcpy(td->td_name, ie->ie_fullname, sizeof(td->td_name));
+#else /* __rtems__ */
+	_Thread_Set_name(td->td_thread, ie->ie_fullname);
+#endif /* __rtems__ */
 #ifdef KTR
 	sched_clear_tdname(td);
Index: freebsd/sys/sys/proc.h
===================================================================
--- freebsd/sys/sys/proc.h	(revision fb288fabeac198d19869ad6d6c6159d69d418d87)
+++ freebsd/sys/sys/proc.h	(revision 172f2acb2b0ad183cb2360843e67aa86ca26a210)
@@ -224,5 +224,4 @@
 	Thread_Control *td_thread;
 	struct rtems_bsd_program_control *td_prog_ctrl;
-	char td_name[32];
 #endif /* __rtems__ */
 #ifndef __rtems__
Index: libbsd.py
===================================================================
--- libbsd.py	(revision fb288fabeac198d19869ad6d6c6159d69d418d87)
+++ libbsd.py	(revision 172f2acb2b0ad183cb2360843e67aa86ca26a210)
@@ -70,5 +70,4 @@
             'rtems/rtems-bsd-rc-conf-pf.c',
             'rtems/rtems-bsd-rc-conf.c',
-            'rtems/rtems-bsd-shell.c',
             'rtems/rtems-bsd-shell-arp.c',
             'rtems/rtems-bsd-shell-ifconfig.c',
Index: libbsd_waf.py
===================================================================
--- libbsd_waf.py	(revision fb288fabeac198d19869ad6d6c6159d69d418d87)
+++ libbsd_waf.py	(revision 172f2acb2b0ad183cb2360843e67aa86ca26a210)
@@ -1111,5 +1111,4 @@
               'rtemsbsd/rtems/rtems-bsd-shell-tcpdump.c',
               'rtemsbsd/rtems/rtems-bsd-shell-vmstat.c',
-              'rtemsbsd/rtems/rtems-bsd-shell.c',
               'rtemsbsd/rtems/rtems-bsd-syscall-api.c',
               'rtemsbsd/rtems/rtems-kernel-assert.c',
Index: rtemsbsd/include/rtems/netcmds-config.h
===================================================================
--- rtemsbsd/include/rtems/netcmds-config.h	(revision fb288fabeac198d19869ad6d6c6159d69d418d87)
+++ rtemsbsd/include/rtems/netcmds-config.h	(revision 172f2acb2b0ad183cb2360843e67aa86ca26a210)
@@ -25,6 +25,4 @@
 extern rtems_shell_cmd_t rtems_shell_ARP_Command;
 
-extern rtems_shell_cmd_t rtems_shell_BSD_Command;
-
 extern rtems_shell_cmd_t rtems_shell_PFCTL_Command;
 
Index: emsbsd/rtems/rtems-bsd-shell.c
===================================================================
--- rtemsbsd/rtems/rtems-bsd-shell.c	(revision fb288fabeac198d19869ad6d6c6159d69d418d87)
+++ 	(revision )
@@ -1,117 +1,0 @@
-/**
- * @file
- *
- * @ingroup rtems_bsd_rtems
- *
- * @brief TODO.
- */
-
-/*
- * Copyright (c) 2009-2014 embedded brains GmbH.  All rights reserved.
- *
- *  embedded brains GmbH
- *  Dornierstr. 4
- *  82178 Puchheim
- *  Germany
- *  <rtems@embedded-brains.de>
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- */
-
-#include <machine/rtems-bsd-kernel-space.h>
-#include <machine/rtems-bsd-thread.h>
-#include <machine/rtems-bsd-support.h>
-
-#include <rtems/bsd/sys/param.h>
-#include <sys/types.h>
-#include <sys/systm.h>
-#include <sys/proc.h>
-
-#include <inttypes.h>
-
-#include <rtems/netcmds-config.h>
-#include <rtems/score/threadimpl.h>
-
-static void
-rtems_bsd_dump_thread(Thread_Control *thread)
-{
-	const struct thread *td = rtems_bsd_get_thread(thread);
-
-	if (td != NULL) {
-		char buf[5];
-		const char *name = td->td_name;
-
-		if (name == NULL || name[0] == '\0') {
-			rtems_object_get_name(thread->Object.id, sizeof(buf), &buf[0]);
-			name = &buf[0];
-		}
-
-		fprintf(
-			stdout,
-			" 0x%08" PRIx32 " | %8" PRIu32 " | %s\n",
-			thread->Object.id,
-			_Thread_Get_priority(thread),
-			name
-		);
-	}
-}
-
-static void
-rtems_bsd_dump_threads(void)
-{
-	fprintf(
-		stdout,
-		"-------------------------------------------------------------------------------\n"
-		"                                  BSD THREADS\n"
-		"------------+----------+-------------------------------------------------------\n"
-		" ID         | PRIORITY | NAME\n"
-		"------------+----------+-------------------------------------------------------\n"
-	);
-
-	rtems_iterate_over_all_threads(rtems_bsd_dump_thread);
-
-	fprintf(
-		stdout,
-		"------------+----------+-------------------------------------------------------\n"
-	);
-}
-
-static const char rtems_bsd_usage[] = "bsd";
-
-#define CMP(s) all || strcasecmp(argv [1], s) == 0
-
-static int
-rtems_bsd_info(int argc, char **argv)
-{
-	rtems_bsd_dump_threads();
-
-	return 0;
-}
-
-rtems_shell_cmd_t rtems_shell_BSD_Command = {
-	.name = "bsd",
-	.usage = &rtems_bsd_usage[0],
-	.topic = "bsp",
-	.command = rtems_bsd_info,
-	.alias = NULL,
-	.next = NULL
-};
Index: rtemsbsd/rtems/rtems-kernel-thread.c
===================================================================
--- rtemsbsd/rtems/rtems-kernel-thread.c	(revision fb288fabeac198d19869ad6d6c6159d69d418d87)
+++ rtemsbsd/rtems/rtems-kernel-thread.c	(revision 172f2acb2b0ad183cb2360843e67aa86ca26a210)
@@ -234,5 +234,5 @@
 	rtems_id task_id;
 	struct thread *td;
-	char name[sizeof(td->td_name)];
+	char name[32];
 
 	BSD_ASSERT(pages >= 0);
@@ -257,5 +257,5 @@
 		BSD_ASSERT(td != NULL);
 
-		memcpy(td->td_name, name, sizeof(name));
+		_Thread_Set_name(thread, name);
 
 		if (rtems_bsd_thread_ready_to_start) {
Index: testsuite/include/rtems/bsd/test/default-network-init.h
===================================================================
--- testsuite/include/rtems/bsd/test/default-network-init.h	(revision fb288fabeac198d19869ad6d6c6159d69d418d87)
+++ testsuite/include/rtems/bsd/test/default-network-init.h	(revision 172f2acb2b0ad183cb2360843e67aa86ca26a210)
@@ -359,5 +359,4 @@
   &bsp_interrupt_shell_command, \
   &rtems_shell_ARP_Command, \
-  &rtems_shell_BSD_Command, \
   &rtems_shell_HOSTNAME_Command, \
   &rtems_shell_PING_Command, \
Index: testsuite/media01/test_main.c
===================================================================
--- testsuite/media01/test_main.c	(revision fb288fabeac198d19869ad6d6c6159d69d418d87)
+++ testsuite/media01/test_main.c	(revision 172f2acb2b0ad183cb2360843e67aa86ca26a210)
@@ -201,5 +201,4 @@
   &bsp_interrupt_shell_command, \
   &rtems_shell_ARP_Command, \
-  &rtems_shell_BSD_Command, \
   &rtems_shell_HOSTNAME_Command, \
   &rtems_shell_PING_Command, \
Index: testsuite/rcconf02/test_main.c
===================================================================
--- testsuite/rcconf02/test_main.c	(revision fb288fabeac198d19869ad6d6c6159d69d418d87)
+++ testsuite/rcconf02/test_main.c	(revision 172f2acb2b0ad183cb2360843e67aa86ca26a210)
@@ -234,5 +234,4 @@
 #define CONFIGURE_SHELL_USER_COMMANDS \
   &bsp_interrupt_shell_command, \
-  &rtems_shell_BSD_Command, \
   &rtems_shell_HOSTNAME_Command, \
   &rtems_shell_PING_Command, \
Index: testsuite/thread01/test_main.c
===================================================================
--- testsuite/thread01/test_main.c	(revision fb288fabeac198d19869ad6d6c6159d69d418d87)
+++ testsuite/thread01/test_main.c	(revision 172f2acb2b0ad183cb2360843e67aa86ca26a210)
@@ -75,5 +75,5 @@
 	assert(td_0 == td_1);
 	assert(td_0 == td_2);
-	assert(strcmp(&td_0->td_name[0], name) == 0);
+	assert(strcmp(td_0->td_thread->Join_queue.Queue.name, name) == 0);
 }
 