Index: testsuites/psxtmtests/Makefile.am
===================================================================
--- testsuites/psxtmtests/Makefile.am	(revision 16d5e3945313e008d45abe9b1956c33f8b17a3a4)
+++ testsuites/psxtmtests/Makefile.am	(revision 183b0ae48832b416ca81a22603cfb0a6d9b796ed)
@@ -472,4 +472,15 @@
 endif
 
+if TEST_psxtmmqrcvblock02
+psxtm_tests += psxtmmqrcvblock02
+psxtm_docs += psxtmmqrcvblock02/psxtmmqrcvblock02.doc
+psxtmmqrcvblock02_SOURCES = psxtmmqrcvblock02/init.c \
+	../tmtests/include/timesys.h ../support/src/tmtests_empty_function.c \
+	../support/src/tmtests_support.c
+psxtmmqrcvblock02_CPPFLAGS = $(AM_CPPFLAGS) $(TEST_FLAGS_psxtmmqrcvblock02) \
+	$(support_includes) -I$(top_srcdir)/../tmtests/include \
+	-DOPERATION_COUNT=$(OPERATION_COUNT)
+endif
+
 if TEST_psxtmsem01
 psxtm_tests += psxtmsem01
Index: testsuites/psxtmtests/configure.ac
===================================================================
--- testsuites/psxtmtests/configure.ac	(revision 16d5e3945313e008d45abe9b1956c33f8b17a3a4)
+++ testsuites/psxtmtests/configure.ac	(revision 183b0ae48832b416ca81a22603cfb0a6d9b796ed)
@@ -72,4 +72,5 @@
 RTEMS_TEST_CHECK([psxtmrwlock07])
 RTEMS_TEST_CHECK([psxtmmqrcvblock01])
+RTEMS_TEST_CHECK([psxtmmqrcvblock02])
 RTEMS_TEST_CHECK([psxtmsem01])
 RTEMS_TEST_CHECK([psxtmsem02])
Index: testsuites/psxtmtests/psxtmmqrcvblock02/init.c
===================================================================
--- testsuites/psxtmtests/psxtmmqrcvblock02/init.c	(revision 183b0ae48832b416ca81a22603cfb0a6d9b796ed)
+++ testsuites/psxtmtests/psxtmmqrcvblock02/init.c	(revision 183b0ae48832b416ca81a22603cfb0a6d9b796ed)
@@ -0,0 +1,134 @@
+/*
+ *  COPYRIGHT (c) 2018.
+ *  Himanshu Sekhar Nayak
+ *
+ *  Permission to use, copy, modify, and/or distribute this software
+ *  for any purpose with or without fee is hereby granted.
+ *
+ *  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
+ *  WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
+ *  WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR
+ *  BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES
+ *  OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
+ *  WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
+ *  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <fcntl.h>
+#include <timesys.h>
+#include <rtems/btimer.h>
+#include <tmacros.h>
+#include "test_support.h"
+#include <sched.h>
+#include <pthread.h>
+#include <mqueue.h>
+#include <signal.h>
+
+const char rtems_test_name[] = "PSXTMMQRCVBLOCK 02";
+
+/* forward declarations to avoid warnings */
+void *POSIX_Init(void *argument);
+void *Middle(void *argument);
+void *Low(void *argument);
+
+#define MQ_MAXMSG     1
+#define MQ_MSGSIZE    sizeof(int)
+
+static mqd_t queue;
+int message[MQ_MAXMSG];
+const char *q_name;
+unsigned int priority;
+struct timespec timeout;
+
+void *POSIX_Init(
+  void *argument
+)
+{
+  int              i;
+  int              status;
+  int              oflag = O_CREAT |O_RDWR;
+  pthread_t        threadId;
+  struct mq_attr   attr;
+
+  priority = 0;
+  timeout.tv_sec  = 0;
+  timeout.tv_nsec = 0;
+  attr.mq_maxmsg  = MQ_MAXMSG;
+  attr.mq_msgsize = MQ_MSGSIZE;
+
+  TEST_BEGIN();
+
+  for ( i=0 ; i < OPERATION_COUNT - 1 ; i++ ) {
+    status = pthread_create( &threadId, NULL, Middle, NULL );
+    rtems_test_assert( !status );
+  }
+
+  status = pthread_create( &threadId, NULL, Low, NULL );
+  rtems_test_assert( !status );
+
+  queue = mq_open( "queue", oflag, 0x777, &attr );
+
+  /* let other threads run */
+  sched_yield();
+
+  /* now run the benchmark */
+  benchmark_timer_initialize();
+  status = mq_timedreceive(
+		  queue, (char *)message, MQ_MSGSIZE, &priority, &timeout);
+  return NULL;
+}
+
+void *Middle(
+  void *argument
+)
+{
+  sched_yield();
+
+    /* let other threads run */
+
+    (void) mq_timedreceive(
+      queue, (char *)message, MQ_MSGSIZE, &priority, &timeout);
+
+  return NULL;
+}
+
+void *Low(
+  void *argument
+)
+{
+  benchmark_timer_t end_time;
+
+  sched_yield();
+
+  end_time = benchmark_timer_read();
+
+  put_time(
+    "mq_timedreceive: not available: block",
+    end_time,
+    OPERATION_COUNT,
+    0,
+    0
+  );
+
+  TEST_END();
+
+  rtems_test_exit( 0 );
+  return NULL;
+}
+
+/* configuration information */
+
+#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER
+#define CONFIGURE_APPLICATION_NEEDS_TIMER_DRIVER
+
+#define CONFIGURE_MAXIMUM_POSIX_THREADS     OPERATION_COUNT + 2
+#define CONFIGURE_POSIX_INIT_THREAD_TABLE
+
+#define CONFIGURE_INIT
+
+#include <rtems/confdefs.h>
+  /* end of file */
Index: testsuites/psxtmtests/psxtmtests_plan.csv
===================================================================
--- testsuites/psxtmtests/psxtmtests_plan.csv	(revision 16d5e3945313e008d45abe9b1956c33f8b17a3a4)
+++ testsuites/psxtmtests/psxtmtests_plan.csv	(revision 183b0ae48832b416ca81a22603cfb0a6d9b796ed)
@@ -129,5 +129,5 @@
 "mq_receive: available",,"psxtmtest_single","Yes"
 "mq_receive: not available: block",,"psxtmtest_blocking","Yes"
-"mq_timedreceive: available",,"psxtmtest_single","Yes"
+"mq_timedreceive: not available: blocks","psxtmmqrcvblock02,"psxtmtest_blocking","Yes"
 "mq_timedreceive: not available: blocks",,"psxtmtest_single","No"
 "mq_send: no threads waiting",,"psxtmtest_single","Yes"