Index: c/src/ada-tests/support/init.c
===================================================================
--- c/src/ada-tests/support/init.c	(revision f3f06f79c34b82beb05532972f04e1bc1fcb7d2d)
+++ c/src/ada-tests/support/init.c	(revision 196a6b9c352e72138f0736147ee154d51ee93561)
@@ -13,16 +13,4 @@
 #include <bsp.h>
 
-#ifdef PROVIDES_GETPID
-#include <unistd.h>
-pid_t getpid()
-{
-#ifndef PID
-  return 1;
-#else
-  return PID;
-#endif
-}
-#endif
-
 void *POSIX_Init(
   void *argument
@@ -36,20 +24,5 @@
 }
 
-/* configuration information */
+#define CONFIGURE_INIT
+#include "config.h"
 
-#define CONFIGURE_SPTEST
-
-#define CONFIGURE_TEST_NEEDS_CONSOLE_DRIVER
-#define CONFIGURE_TEST_NEEDS_CLOCK_DRIVER
-
-#define CONFIGURE_POSIX_INIT_THREAD_TABLE
-
-#define CONFIGURE_MAXIMUM_POSIX_THREADS              20
-#define CONFIGURE_MAXIMUM_POSIX_KEYS                 20
-#define CONFIGURE_MAXIMUM_POSIX_MUTEXES              30
-#define CONFIGURE_MAXIMUM_POSIX_CONDITION_VARIABLES  20
-
-#define CONFIGURE_INIT
-
-#include <confdefs.h>
-
Index: c/src/ada-tests/support/status_io.ads
===================================================================
--- c/src/ada-tests/support/status_io.ads	(revision f3f06f79c34b82beb05532972f04e1bc1fcb7d2d)
+++ c/src/ada-tests/support/status_io.ads	(revision 196a6b9c352e72138f0736147ee154d51ee93561)
@@ -11,13 +11,13 @@
 --  
 --
---  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  COPYRIGHT (c) 1989-1997.
 --  On-Line Applications Research Corporation (OAR).
---  All rights assigned to U.S. Government, 1994.
+--  Copyright assigned to U.S. Government, 1994.
 --
---  This material may be reproduced by or for the U.S. Government pursuant
---  to the copyright license under the clause at DFARS 252.227-7013.  This
---  notice must appear in all copies of this file and its derivatives.
+--  The license and distribution terms for this file may in
+--  the file LICENSE in this distribution or at
+--  http://www.OARcorp.com/rtems/license.html.
 --
---  status_io.ads,v 1.2 1995/05/31 16:28:20 joel Exp
+--  $Id$
 --
 
Index: c/src/ada-tests/support/test_support.adb
===================================================================
--- c/src/ada-tests/support/test_support.adb	(revision f3f06f79c34b82beb05532972f04e1bc1fcb7d2d)
+++ c/src/ada-tests/support/test_support.adb	(revision 196a6b9c352e72138f0736147ee154d51ee93561)
@@ -11,13 +11,13 @@
 --  
 --
---  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  COPYRIGHT (c) 1989-1997.
 --  On-Line Applications Research Corporation (OAR).
---  All rights assigned to U.S. Government, 1994.
---
---  This material may be reproduced by or for the U.S. Government pursuant
---  to the copyright license under the clause at DFARS 252.227-7013.  This
---  notice must appear in all copies of this file and its derivatives.
---
---  test_support.adb,v 1.2 1995/07/21 15:08:54 joel Exp
+--  Copyright assigned to U.S. Government, 1994.
+--
+--  The license and distribution terms for this file may in
+--  the file LICENSE in this distribution or at
+--  http://www.OARcorp.com/rtems/license.html.
+--
+--  $Id$
 --
 
Index: c/src/ada-tests/support/test_support.ads
===================================================================
--- c/src/ada-tests/support/test_support.ads	(revision f3f06f79c34b82beb05532972f04e1bc1fcb7d2d)
+++ c/src/ada-tests/support/test_support.ads	(revision 196a6b9c352e72138f0736147ee154d51ee93561)
@@ -11,13 +11,13 @@
 --  
 --
---  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  COPYRIGHT (c) 1989-1997.
 --  On-Line Applications Research Corporation (OAR).
---  All rights assigned to U.S. Government, 1994.
+--  Copyright assigned to U.S. Government, 1994.
 --
---  This material may be reproduced by or for the U.S. Government pursuant
---  to the copyright license under the clause at DFARS 252.227-7013.  This
---  notice must appear in all copies of this file and its derivatives.
+--  The license and distribution terms for this file may in
+--  the file LICENSE in this distribution or at
+--  http://www.OARcorp.com/rtems/license.html.
 --
---  test_support.ads,v 1.1 1995/07/12 19:38:15 joel Exp
+--  $Id$
 --
 
Index: c/src/ada-tests/support/unsigned32_io.ads
===================================================================
--- c/src/ada-tests/support/unsigned32_io.ads	(revision f3f06f79c34b82beb05532972f04e1bc1fcb7d2d)
+++ c/src/ada-tests/support/unsigned32_io.ads	(revision 196a6b9c352e72138f0736147ee154d51ee93561)
@@ -11,13 +11,13 @@
 --  
 --
---  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+--  COPYRIGHT (c) 1989-1997.
 --  On-Line Applications Research Corporation (OAR).
---  All rights assigned to U.S. Government, 1994.
+--  Copyright assigned to U.S. Government, 1994.
 --
---  This material may be reproduced by or for the U.S. Government pursuant
---  to the copyright license under the clause at DFARS 252.227-7013.  This
---  notice must appear in all copies of this file and its derivatives.
+--  The license and distribution terms for this file may in
+--  the file LICENSE in this distribution or at
+--  http://www.OARcorp.com/rtems/license.html.
 --
---  unsigned32_io.ads,v 1.1 1995/07/12 19:37:33 joel Exp
+--  $Id$
 --
 