Index: c/src/lib/libbsp/m68k/mvme162/ChangeLog
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/ChangeLog	(revision ab98fac8c407da54a98eb7379d30a599ef619eba)
+++ c/src/lib/libbsp/m68k/mvme162/ChangeLog	(revision 203cb9a7355beebdf8a5632cf11cb8130e372022)
@@ -1,2 +1,15 @@
+2003-12-03	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* Makefile.am: Add preinstallation dirstamp support.
+	* clock/Makefile.am: Cosmetics.
+	* console/Makefile.am: Cosmetics.
+	* consolex/Makefile.am: Add preinstallation dirstamp support.
+	* network/Makefile.am: Cosmetics.
+	* startup/Makefile.am: Cosmetics.
+	* timer/Makefile.am: Cosmetics.
+	* tod/Makefile.am: Cosmetics.
+	* tools/Makefile.am: Cosmetics.
+	* wrapup/Makefile.am: Cosmetics.
+
 2003-12-02	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: c/src/lib/libbsp/m68k/mvme162/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/Makefile.am	(revision ab98fac8c407da54a98eb7379d30a599ef619eba)
+++ c/src/lib/libbsp/m68k/mvme162/Makefile.am	(revision 203cb9a7355beebdf8a5632cf11cb8130e372022)
@@ -29,19 +29,21 @@
 EXTRA_DIST = times
 
-$(PROJECT_INCLUDE)/coverhd.h: include/coverhd.h
+    $(top_srcdir)/../shared/mvme/mvme16x_hw.h
 	$(INSTALL_DATA) $< $@
+
+$(PROJECT_INCLUDE)/coverhd.h: include/coverhd.h $(PROJECT_INCLUDE)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/coverhd.h
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/coverhd.h
 
-$(PROJECT_INCLUDE)/page_table.h: include/page_table.h
-	$(INSTALL_DATA) $< $@
+$(PROJECT_INCLUDE)/page_table.h: include/page_table.h $(PROJECT_INCLUDE)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/page_table.h
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/page_table.h
 
-$(PROJECT_INCLUDE)/tod.h: include/tod.h
-	$(INSTALL_DATA) $< $@
+$(PROJECT_INCLUDE)/tod.h: include/tod.h $(PROJECT_INCLUDE)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/tod.h
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/tod.h
 
-$(PROJECT_INCLUDE)/mvme16x_hw.h: \
-    $(top_srcdir)/../shared/mvme/mvme16x_hw.h
-	$(INSTALL_DATA) $< $@
+$(PROJECT_INCLUDE)/mvme16x_hw.h: $(top_srcdir)/../shared/mvme/mvme16x_hw.h $(PROJECT_INCLUDE)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/mvme16x_hw.h
 PREINSTALL_FILES += $(PROJECT_INCLUDE)/mvme16x_hw.h
 
Index: c/src/lib/libbsp/m68k/mvme162/clock/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/clock/Makefile.am	(revision ab98fac8c407da54a98eb7379d30a599ef619eba)
+++ c/src/lib/libbsp/m68k/mvme162/clock/Makefile.am	(revision 203cb9a7355beebdf8a5632cf11cb8130e372022)
@@ -2,5 +2,4 @@
 ## $Id$
 ##
-
 
 PGM = $(ARCH)/clock.rel
Index: c/src/lib/libbsp/m68k/mvme162/console/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/console/Makefile.am	(revision ab98fac8c407da54a98eb7379d30a599ef619eba)
+++ c/src/lib/libbsp/m68k/mvme162/console/Makefile.am	(revision 203cb9a7355beebdf8a5632cf11cb8130e372022)
@@ -2,5 +2,4 @@
 ## $Id$
 ##
-
 
 PGM = $(ARCH)/console.rel
Index: c/src/lib/libbsp/m68k/mvme162/consolex/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/consolex/Makefile.am	(revision ab98fac8c407da54a98eb7379d30a599ef619eba)
+++ c/src/lib/libbsp/m68k/mvme162/consolex/Makefile.am	(revision 203cb9a7355beebdf8a5632cf11cb8130e372022)
@@ -2,5 +2,4 @@
 ## $Id$
 ##
-
 
 PGM = $(ARCH)/consolex.rel
@@ -23,13 +22,4 @@
 	$(make-rel)
 
-$(PROJECT_INCLUDE):
-	$(mkinstalldirs) $@
-
-$(PROJECT_INCLUDE)/%.h: %.h
-	$(INSTALL_DATA) $< $@
-
-TMPINSTALL_FILES += $(PROJECT_INCLUDE) \
-    $(include_HEADERS:%=$(PROJECT_INCLUDE)/%)
-
 all-local: $(OBJS) $(PGM) $(TMPINSTALL_FILES)
 
@@ -38,3 +28,14 @@
 EXTRA_DIST = README cTest.c consolex.c consolex.h
 
+PREINSTALL_FILES =
+
+$(PROJECT_INCLUDE)/$(dirstamp):
+	@$(mkinstalldirs) $(PROJECT_INCLUDE)
+	@: > $(PROJECT_INCLUDE)/$(dirstamp)
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/$(dirstamp)
+
+$(PROJECT_INCLUDE)/consolex.h: consolex.h $(PROJECT_INCLUDE)/$(dirstamp)
+	$(INSTALL_DATA) $< $(PROJECT_INCLUDE)/consolex.h
+PREINSTALL_FILES += $(PROJECT_INCLUDE)/consolex.h
+
 include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/m68k/mvme162/network/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/network/Makefile.am	(revision ab98fac8c407da54a98eb7379d30a599ef619eba)
+++ c/src/lib/libbsp/m68k/mvme162/network/Makefile.am	(revision 203cb9a7355beebdf8a5632cf11cb8130e372022)
@@ -2,5 +2,4 @@
 ## $Id$
 ##
-
 
 VPATH = @srcdir@:@srcdir@/../../mvme167/network
Index: c/src/lib/libbsp/m68k/mvme162/startup/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/startup/Makefile.am	(revision ab98fac8c407da54a98eb7379d30a599ef619eba)
+++ c/src/lib/libbsp/m68k/mvme162/startup/Makefile.am	(revision 203cb9a7355beebdf8a5632cf11cb8130e372022)
@@ -2,5 +2,4 @@
 ## $Id$
 ##
-
 
 VPATH = @srcdir@:@srcdir@/../../shared:@srcdir@/../../../shared
Index: c/src/lib/libbsp/m68k/mvme162/timer/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/timer/Makefile.am	(revision ab98fac8c407da54a98eb7379d30a599ef619eba)
+++ c/src/lib/libbsp/m68k/mvme162/timer/Makefile.am	(revision 203cb9a7355beebdf8a5632cf11cb8130e372022)
@@ -2,5 +2,4 @@
 ## $Id$
 ##
-
 
 PGM = $(ARCH)/timer.rel
Index: c/src/lib/libbsp/m68k/mvme162/tod/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/tod/Makefile.am	(revision ab98fac8c407da54a98eb7379d30a599ef619eba)
+++ c/src/lib/libbsp/m68k/mvme162/tod/Makefile.am	(revision 203cb9a7355beebdf8a5632cf11cb8130e372022)
@@ -2,5 +2,4 @@
 ## $Id$
 ##
-
 
 PGM = $(ARCH)/tod.rel
Index: c/src/lib/libbsp/m68k/mvme162/tools/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/tools/Makefile.am	(revision ab98fac8c407da54a98eb7379d30a599ef619eba)
+++ c/src/lib/libbsp/m68k/mvme162/tools/Makefile.am	(revision 203cb9a7355beebdf8a5632cf11cb8130e372022)
@@ -16,2 +16,3 @@
 endif
 include $(top_srcdir)/../../../../../automake/host.am
+
Index: c/src/lib/libbsp/m68k/mvme162/wrapup/Makefile.am
===================================================================
--- c/src/lib/libbsp/m68k/mvme162/wrapup/Makefile.am	(revision ab98fac8c407da54a98eb7379d30a599ef619eba)
+++ c/src/lib/libbsp/m68k/mvme162/wrapup/Makefile.am	(revision 203cb9a7355beebdf8a5632cf11cb8130e372022)
@@ -11,8 +11,10 @@
 
 # bummer; have to use $foreach since % pattern subst rules only replace 1x
-OBJS = $(foreach piece, $(BSP_PIECES), $(wildcard ../$(piece)/$(ARCH)/*.$(OBJEXT))) \
-    $(wildcard ../consolex/$(ARCH)/consolex.rel) \
-    $(wildcard ../../../../libcpu/$(RTEMS_CPU)/shared/misc/$(ARCH)/*.$(OBJEXT)) \
-    $(wildcard ../../../../libcpu/$(RTEMS_CPU)/$(RTEMS_CPU_MODEL)/fpsp/$(ARCH)/fpsp.rel)
+OBJS = $(foreach piece, $(BSP_PIECES), $(wildcard \
+    ../$(piece)/$(ARCH)/*.$(OBJEXT))) $(wildcard \
+    ../consolex/$(ARCH)/consolex.rel) $(wildcard \
+    ../../../../libcpu/$(RTEMS_CPU)/shared/misc/$(ARCH)/*.$(OBJEXT)) \
+    $(wildcard \
+    ../../../../libcpu/$(RTEMS_CPU)/$(RTEMS_CPU_MODEL)/fpsp/$(ARCH)/fpsp.rel)
 
 LIB = $(ARCH)/libbsp.a